//*****************************************
// AT mega328P-AU(32pin TQFP) four IN-4 & ZM1020 clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:display.c
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2020/09/24 Modify for four IN-8 clock Taishi
//  2022/02/26 Modify for four IN-4 & ZM1020 clock Taishi
//*****************************************

#include	"four_in4_zm1020_clock.h"
#include	"nixie.h"
#include	"display.h"

//*****************************************
// Pabc̕\
//@F\JniOFŏʁAPSFŉʁj
//@FPabc̒l(D0--D3)
//*****************************************
void	disp_nixie_one(unsigned char n,unsigned char bcd)
{
	disp_dynamic_nixie_number(n, bcd & 0x0f);
}
//*****************************************
// Qabc̕\
//@F\JniOFŏʁAPSFŉʁj
//@FQabc̒l
//*****************************************
void	disp_nixie_tow(unsigned char n,unsigned char bcd)
{
	disp_dynamic_nixie_number(n+0, bcd >> 4);		// 
	disp_dynamic_nixie_number(n+1, bcd & 0x0f);	// 
}
//*****************************************
//  Qabc̕\
//*****************************************
void	disp_nixie_tow_h(unsigned char bcd)
{
	disp_nixie_tow(0, bcd);				// Qabc̕\
}
//*****************************************
//  Qabc̕\
//*****************************************
void	disp_nixie_tow_m(unsigned char bcd)
{
	disp_nixie_tow(2, bcd);				// Qabc̕\
}
//*****************************************
//  Qabc̕\
//*****************************************
void	disp_nixie_tow_l(unsigned char bcd)
{
	disp_nixie_tow(4, bcd);				// Qabc̕\
}
//*****************************************
// Sabc̕\
//*****************************************
void	disp_nixie_four(unsigned char bcd_h, unsigned char bcd_l)
{
	disp_nixie_tow(0, bcd_h);				// Qabc̕\
	disp_nixie_tow(2, bcd_l);				// Qabc̕\
}
//*****************************************
// Uabc̕\
//*****************************************
void	disp_nixie_six(unsigned char bcd_h, unsigned char bcd_m, unsigned char bcd_l)
{
	disp_nixie_tow(0, bcd_h);				// Qabc̕\
	disp_nixie_tow(2, bcd_m);				// Qabc̕\
	disp_nixie_tow(4, bcd_l);				// Qabc̕\
}
//*****************************************
// S\iXXXX܂Łj
//@F\JniOFŏʁATFŉʁj
//*****************************************
void	disp_nixie_4binary(unsigned char n,unsigned short us)
{
	if(9999 < us){
		us = 9999;
	}
	disp_dynamic_nixie_number(n+0, us/1000);		// 
	disp_dynamic_nixie_number(n+1, (us%1000)/100);	// 2
	disp_dynamic_nixie_number(n+2, (us%100)/10);	// 3
	disp_dynamic_nixie_number(n+3, us%10);			// 

}
