//*****************************************
// AT mega328P-AU(32pin TQFP) four IN-4 & ZM1020 clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:eep_dat.c
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2020/09/24 Modify for four IN-8 clock Taishi
//  2022/02/26 Modify for four IN-4 & ZM1020 clock Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/eeprom.h>

#include	"four_in4_zm1020_clock.h"
#include	"port_bit.h"
#include	"timer.h"
#include	"ad_conv.h"
#include	"nixie.h"
#include	"uart.h"
#include	"display.h"
#include	"rtc_ds3234.h"
#include	"eep_dat.h"

//uint16_t	eep_bps_600 EEMEM = BPS_600;			// UOOaor̒l
uint16_t	eep_bps_600 EEMEM = 814;			// ݓ삵Ă̂bot̂UOOaor̒lifobOj
unsigned char	eep_change_path EEMEM = 6;				// ۑ \Ԉؑ֒l 0--9 (0:bright -- 9:dark ̒lPOOؑ֒l)
static	unsigned short	eep_bfs[10];

//*****************************************
//@ddoqnl BPS_600 ǂݍ
//*****************************************
unsigned short	read_eep_bps_600(void)
{
	unsigned short	r = 0;

	eeprom_busy_wait();
	eep_bfs[0] = eeprom_read_word(&eep_bps_600);		// Ǐo
	if((800 <= eep_bfs[0])&&(eep_bfs[0] <= 900)){
		r = eep_bfs[0];
	}else{
		r = BPS_600;
	}

	return(r);
}

//*****************************************
//@ddoqnl BPS_600 
//*****************************************
void	write_eep_bps_600(unsigned short us)
{
	eep_bfs[0] = us;
	eeprom_busy_wait();
	eeprom_write_word(&eep_bps_600, eep_bfs[0]);		// 
	eeprom_busy_wait();
}
//***************************
// ␳aorUOOvZ
// uc : ^C}[P̃JE^[lłWlgȂ΂VWPR̔
// ␳lVWPRaorQUOO
//***************************
static
unsigned short calcu_bps600(unsigned short us)
{
	unsigned short r;
	unsigned long ul;

	ul = us;
	ul *= (unsigned long)(BPS_600);
	ul /= (unsigned long)7813;
	r = (unsigned short)ul;

	return(r);

}
//***************************
// aorUOO̒lC
//  kdcSx_ł
//  XCb`ėꂽ 
//@aorUOO̒lŉʂRɕ\BiWlg҂ȂWRRj
//@qsb̂PbM̃^C~OłaorUOO̒lXV
//  rdsXCb`ꂽ@݂̂aorUOO̒lɏ݈Ȍケ̒lg
//***************************
static
void	edit_bps600(void)
{
	unsigned short	us;
	unsigned short	t1_count = 7813;
	unsigned short	bps600 = BPS_600;
	unsigned char	old_rtc_1s_flg=0xff;

	bps600 = gBPS_600;

	get_sw();

	timer1_init();									// Timer1 Initial
	tim_10ms_blink = 0;								// uNp^C}[𗬗p
	sei();											// 荞݉
	delay_ms(10);									// 10mS Delay
	get_sw();
	delay_ms(10);									// 10mS Delay
	get_sw();
	delay_ms(10);									// 10mS Delay

	led_red_off();										// LED OFF
	tim_10ms_ad = 0;
	disp_dynamic_nixie_clear();						// Nixie \SAR
	disp_nixie_4binary(0,bps600);					// S\iXXXX܂Łj
	dynamic_nixie_active(1);						// _Ci~bN\Jn
	delay_ms(1000);									// 1S Delay

	// ŏ̈͒l肵Ȃ̂ŃX[
	for(;;){
		if(rtc_1s_flg != old_rtc_1s_flg){						// qsbĂ鎞̂Pboߗp
			TCNT1 = 0;											// sbmsP@NA
			old_rtc_1s_flg = rtc_1s_flg;
			break;
		}
	}
	for(;;){
		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ

		if(us == SW1_OFF_LONG){									// XCb`ėꂽ(set switch)
			cli();
			write_eep_bps_600(bps600);							//@ddoqnl BPS_600 
			sei();												// 荞݉
			led_red_on();											// LED ON
			delay_ms(100);										// 100mS Delay
			led_red_off();											// LED OFF
		}else if(us == SW1_OFF_SHORT){							// Zꂽ(set switch)
			break;
		}else if(us == SW2_OFF_SHORT){							// Zꂽ(select switch)
			break;
		}

		if(rtc_1s_flg != old_rtc_1s_flg){						// qsbĂ鎞̂Pboߗp
			t1_count = TCNT1;									// sbmsPǂݏo
			TCNT1 = 0;											// sbmsP@NA
			old_rtc_1s_flg = rtc_1s_flg;
//			disp_nixie_4binary(0,t1_count);						// S\iXXXX܂Łj
			bps600 = calcu_bps600(t1_count);					// ␳aorUOOvZ
			disp_nixie_4binary(0,bps600);						// S\iXXXX܂Łj
		}
	}

	timer1_close();												// Timer1 close

}

//*****************************************
//@ddoqnl change_PATH ǂݍ
//*****************************************
unsigned char	read_eep_change_path(void)
{
	unsigned char	r = 0;

	eeprom_busy_wait();
	eep_bfs[0] = eeprom_read_byte(&eep_change_path);		// Ǐo
	if((0 <= eep_bfs[0])&&(eep_bfs[0] <= 9)){
		r = eep_bfs[0];
	}else{
		r = 9;
	}

	return(r);
}

//*****************************************
//@ddoqnl change_PATH 
//*****************************************
static
void	write_eep_change_path(unsigned char uc)
{
	eep_bfs[0] = uc;
	eeprom_busy_wait();
	eeprom_write_byte(&eep_change_path, eep_bfs[0]);		// 
	eeprom_busy_wait();
}

//*****************************************
//@ddoqnlchange_PATHҏW
//*****************************************
static
void	edit_eep_change_path(void)
{
	unsigned short	us;
	unsigned char	pt;
	unsigned char	blk_stat = 0;
	unsigned char	blink_time = 30;					// uNԊu

	pt = change_path;
	disp_dynamic_nixie_number(0, 15);
	disp_dynamic_nixie_number(1, pt);
	disp_dynamic_nixie_number(2, 0);
	disp_dynamic_nixie_number(3, 0);

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();									// XCb`Ԃ
		us = us & SW_MASK;										// XCb`ɂ

		if(tim_10ms_blink == 0){								// _Ń^C~O̎
			tim_10ms_blink = blink_time;
			if((blk_stat==0)&&((us & SW2_ON) == 0)&&((us & SW1_ON) == 0)){			// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_dynamic_nixie_number(1, 15);
			}else{
				blk_stat = 0;
				disp_dynamic_nixie_number(1, pt);
			}
		}

		if(us != 0){											// EANVL鎞
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_OFF_SHORT) != 0)){	// ꑱAZꂽ(select switch)

				if(9 <= pt){
					pt = 0;
				}else{
					pt++;
				}
				disp_dynamic_nixie_number(1, pt);				// l̂P\
				tim_10ms_blink = blink_time;					// uNԊu
			}else if((us & SW1_OFF_LONG) != 0){					// Aꎞ(set switch)
				cli();
				change_path = pt;
				write_eep_change_path(change_path);				// ddoqnl change_PATH ɏ
				led_red_on();										// LED ON
				delay_ms(100);									// 100mS Delay
				led_red_off();										// LED OFF
				sei();											// 荞݉
			}else if((us & SW1_OFF_SHORT) != 0){				// ZAꎞ(set switch)
				break;
			}
		}

	}

}

//*****************************************
//@ddoqnlDATAҏW
//  iv[v
//*****************************************
void	edit_eep_data(void)
{
	led_red_on();										// LED ON
	delay_ms(500);									// 500mS Delay
	led_red_off();										// LED OFF
	delay_ms(500);									// 500mS Delay
	led_red_on();										// LED ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led_red_off();										// LED OFF
	delay_ms(500);									// 500mS Delay
	led_red_on();										// LED ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led_red_off();										// LED OFF
	delay_ms(500);									// 500mS Delay
	led_red_on();										// LED ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led_red_off();										// LED OFF


	while(1){
		edit_bps600();								// aorUOO̒lC

		edit_eep_change_path();						// ddoqnlchange_PATHҏW
	}
}
