//*****************************************
// AT mega328P-AU(32pin TQFP) four IN-4 & ZM1020 clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:four_in4_zm1020_clock.c
//@ pr_six_in16_clock ̃vWFNgRs[ā@pr_four_in8_clock@ɂ킹B
//
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2020/09/24 Modify for four IN-8 clock Taishi
//  2022/02/26 Modify for four IN-4 & ZM1020 clock Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>


#include	"four_in4_zm1020_clock.h"
#include	"timer.h"
#include	"port_bit.h"
#include	"display.h"
#include	"ad_conv.h"
#include	"nixie.h"
#include	"rtc_ds3234.h"
#include	"set_rtc.h"
#include	"eep_dat.h"
#include	"uart.h"
#include	"infrared.h"

unsigned char			g_keta;

static	unsigned char	run=0;
static	int				bef1_ad_ave=0;
//static	unsigned char	renzoku[16]=      {1,0,2,9,3,8,4,7,5,6,15,15,15,15,15,15};		// ̑w̑w
//static	unsigned char	gyaku_renzoku[16]={6,5,7,4,8,3,9,2,0,1,15,15,15,15,15,15};		// ̑w牺̑w

static	unsigned char	renzoku[16]=      {1,7,3,5,9,0,4,6,2,8,15,15,15,15,15,15};		// ̑w̑w
static	unsigned char	gyaku_renzoku[16]={8,2,6,4,0,9,5,3,7,1,15,15,15,15,15,15};		// ̑w牺̑w


//***************************
// `FbNiX^eBbN\js
//  kdcRx_łAŏʂɂO\
//  R_Ă鎞 XCb`閈ɂnm^neeJԂA
//  e̐\Ă鎞 XCb`閈ɂO`XAc|kAc|qԂɕ\
//  XCb` \錅ړB ԍ珇ԂɉEiʌjֈړAԉE͈̎ԍɖ߂
//***************************
void	check_static(void)
{
	unsigned short	us;
	unsigned char	kazu = 0;
	unsigned char	keta = 0;

	led_red_on();									// LED ON
	delay_ms(500);									// 500mS Delay
	led_red_off();									// LED OFF
	delay_ms(500);									// 500mS Delay
	led_red_on();									// LED ON
	delay_ms(500);									// 500mS Delay
	led_red_off();									// LED OFF
	delay_ms(500);									// 500mS Delay
	led_red_on();									// LED ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led_red_off();									// LED OFF

	get_sw();

	sei();											// 荞݉
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay

	bef1_ad_ave = 0;
	keta = 0;
	kazu = 0;
	disp_static_nixie_number(keta, kazu);			// 
	led_red_off();									// LED OFF
	tim_10ms_ad = 0;

	for(;;){
		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ

		if((us == SW2_OFF_SHORT)||(us == SW2_OFF_LONG)){		// XCb`NbNꂽ(select switch)
			kazu++;
			if(9 < kazu){
				kazu = 0;
			}
			if(keta == KETA_SEL_MAX){
				disp_static_colon_on_off(1);					// Colon : ON
			}else{
				disp_static_nixie_number(keta, kazu);			// 
			}
			led_red_on();										// LED ON
			delay_ms(200);										// 200mS Delay
			led_red_off();										// LED OFF
		}

		if((us == SW1_OFF_SHORT)||(us == SW1_OFF_LONG)){		// XCb`NbNꂽ(set switch)
			keta++;
			if(KETA_SEL_MAX < keta){
				keta = 0;
			}
			if(keta == KETA_SEL_MAX){
				disp_static_colon_on_off(1);					// Colon : ON
			
			}else{
				disp_static_nixie_number(keta, kazu);			// 
			}
			led_red_on();										// LED ON
			delay_ms(200);										// 200mS Delay
			led_red_off();										// LED OFF
		}
	}

}
//***************************
// `FbNi_Ci~bN\js
//  kdcQx_ł
//  XCb`ėꂽ eO`XAĕ\iPbԊuŕ\ωj
//    ԉĚ̎̓R\
//***************************
void	check_dynamic(void)
{
	unsigned short	us;
	unsigned char	old_run = 0;
	unsigned char	kazu = 0;
	unsigned char	keta = 0;
	unsigned char	old_keta = 1;
	unsigned char	pause = 0;

	led_red_on();										// LED ON
	delay_ms(500);									// 500mS Delay
	led_red_off();										// LED OFF
	delay_ms(500);									// 500mS Delay
	led_red_on();										// LED ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led_red_off();										// LED OFF

	get_sw();

	tim_10ms_blink = 0;								// uNp^C}[𗬗p
	old_run = run;
	sei();											// 荞݉
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay

	bef1_ad_ave = 0;
	led_red_off();										// LED OFF
	tim_10ms_ad = 0;
	disp_dynamic_nixie_clear();						// Nixie \SA
	dynamic_nixie_active(1);						// _Ci~bN\Jn

	for(;;){
		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ

		if(us == SW2_OFF_SHORT){								// XCb`Zėꂽ(select switch)
			pause ^= 1;											// ړ\𒆒f or Jn
		}

		if(tim_10ms_blink == 0){
			tim_10ms_blink = 100;								// 1000mS Ԋu
			if(pause == 0){
				if(old_keta != keta){							// ς
					disp_dynamic_nixie_number(old_keta, 15);	// Ǒ̐
					disp_dynamic_colon_on_off(0);
					old_keta = keta;
				}
				if(keta == KETA_SEL_MAX){						// Colon
					disp_dynamic_nixie_number(keta, 15);		// 
					disp_dynamic_colon_on_off(1);
					kazu = 9;									// ̌@Oɖ߂߂Ɂ@Xɂ
				}else{
					if(kazu <= 9){
						disp_dynamic_colon_on_off(0);
						disp_dynamic_nixie_number(keta, kazu);	// 
					}
				}
				kazu++;
				if(9 < kazu){									// \POȏɂȂ
					kazu = 0;									// Oɖ߂
					keta++;
					if(KETA_SEL_MAX < keta){					// \߂
						keta = 0;
					}
				}
			}
		}
	}

}

//***************************
// ␳aorUOOvZ
// uc : ^C}[P̃JE^[lłWlgȂ΂VWPR̔
// ␳lVWPRaorQUOO
//***************************
unsigned short calc_bps600(unsigned short us)
{
	unsigned short r;
	unsigned long ul;

	ul = us;
	ul *= (unsigned long)(BPS_600);
	ul /= (unsigned long)7813;
	r = (unsigned short)ul;

	return(r);

}
//***************************
// aorUOO̒l`FbN
//  kdcSx_ł
//  XCb`ėꂽ 
//@^C}[P̒lŏʂɂS\BiWlg҂ȂVWPRj
//@aorUOO̒lŉʂRɕ\BiWlg҂ȂWRRj
//@qsb̂PbM̃^C~OŃ^C}[P̒lƂaorUOO̒lXV
//  rdsXCb`Zꂽ@݂̂aorUOO̒lɏ݈Ȍケ̒lg
//***************************
void	check_bps600(void)
{
	unsigned short	us;
	unsigned short	t1_count = 7813;
	unsigned short	bps600 = 833;
	unsigned char	old_rtc_1s_flg=0xff;

	bps600 = gBPS_600;

	led_red_on();										// LED ON
	delay_ms(500);									// 500mS Delay
	led_red_off();										// LED OFF
	delay_ms(500);									// 500mS Delay
	led_red_on();										// LED ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led_red_off();										// LED OFF
	delay_ms(500);									// 500mS Delay
	led_red_on();										// LED ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led_red_off();										// LED OFF
	delay_ms(500);									// 500mS Delay
	led_red_on();										// LED ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led_red_off();										// LED OFF

	get_sw();

	timer1_init();									// Timer1 Initial
	tim_10ms_blink = 0;								// uNp^C}[𗬗p
	sei();											// 荞݉
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay
	get_sw();
	delay_ms(10);									// 100mS Delay

	bef1_ad_ave = 0;
	led_red_off();										// LED OFF
	tim_10ms_ad = 0;
	disp_dynamic_nixie_clear();						// Nixie \SAR
	disp_nixie_4binary(8,bps600);					// S\iXXXX܂Łj
	dynamic_nixie_active(1);						// _Ci~bN\Jn
	delay_ms(1000);									// 1S Delay

	// ŏ̈͒l肵Ȃ̂ŃX[
	for(;;){
		if(rtc_1s_flg != old_rtc_1s_flg){						// qsbĂ鎞̂Pboߗp
			TCNT1 = 0;											// sbmsP@NA
			old_rtc_1s_flg = rtc_1s_flg;
			break;
		}
	}
	for(;;){
		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ

		if(us == SW1_OFF_SHORT){								// XCb`Zėꂽ(set switch)
			write_eep_bps_600(bps600);							//@ddoqnl BPS_600 
		}

		if(rtc_1s_flg != old_rtc_1s_flg){						// qsbĂ鎞̂Pboߗp
			t1_count = TCNT1;									// sbmsPǂݏo
			TCNT1 = 0;											// sbmsP@NA
			old_rtc_1s_flg = rtc_1s_flg;
			disp_nixie_4binary(0,t1_count);						// S\iXXXX܂Łj
			bps600 = calc_bps600(t1_count);						// ␳aorUOOvZ
			disp_nixie_4binary(8,bps600);						// S\iXXXX܂Łj
		}
	}

}

//***************************
// Aj[V\
//@ODPbɌĂ΂
// 
//@FP̂
// ߂l
//@OAj[Vr
//@PAj[VI
//***************************
unsigned char	disp_animation(unsigned char init)
{
	static	unsigned char	ani_keta = 0;		//  0--3,4(colon)
	static	unsigned char	ani_kazu = 0;		// l 0--9
	unsigned char			r = 0;

	if (init == 1){
		ani_keta = 0;
		ani_kazu = 0;
	}else{
		if(ani_kazu == 0){
			disp_dynamic_nixie_clear();						// Nixie \SColon
			ani_kazu = 0;
		}

		if(KETA_SEL_MAX == ani_keta){								// at Colon
			disp_dynamic_colon_on_off(1);							// Colon ON
			ani_kazu = 9;											// ̐Oɂ邽
		}else{
			if((ani_keta & 1) == 0){									// 
				disp_dynamic_colon_on_off(0);							// Colon OFF
				disp_dynamic_nixie_number(ani_keta, renzoku[ani_kazu]);
			}else{														// E
				disp_dynamic_colon_on_off(0);							// Colon OFF
				disp_dynamic_nixie_number(ani_keta, gyaku_renzoku[ani_kazu]);
			}
		}

		ani_kazu++;
		if(9 < ani_kazu){
			ani_kazu = 0;
			ani_keta++;										// ̌
			if(KETA_SEL_MAX < ani_keta){
				ani_keta = 0;
				r = 1;
			}
		}
	}

	return(r);
}

//***************************
// ԊORf[^XCb`f[^ɕϊ
//***************************
unsigned short	trans_if_to_sw(unsigned char if_data)
{
	unsigned short	us = 0;
	static unsigned short	sw_stat = 0;

	switch(if_data){
	 case IND1_ON_NOW:			// set n߂
		us = SW1_ON_NOW;
		sw_stat |= SW1_ON;
		break;
	 case IND1_ON_CONTINUE:		// set A
		us = SW1_ON_CONTINUE;
		break;
	 case IND1_OFF_SHORT:		// set Zė
		us = SW1_OFF_SHORT;
		sw_stat &= ~(SW1_ON);
		break;
	 case IND1_OFF_LONG:		// set ė
		us = SW1_OFF_LONG;
		sw_stat &= ~(SW1_ON);
		break;
	 case IND2_ON_NOW:			// select n߂
		us = SW2_ON_NOW;
		sw_stat |= SW2_ON;
		break;
	 case IND2_ON_CONTINUE:		// select A
		us = SW2_ON_CONTINUE;
		break;
	 case IND2_OFF_SHORT:		// select Zė
		us = SW2_OFF_SHORT;
		sw_stat &= ~(SW2_ON);
		break;
	 case IND2_OFF_LONG:		// select ė
		us = SW2_OFF_LONG;
		sw_stat &= ~(SW2_ON);
		break;
	}

	us |= sw_stat;
	return(us);
}


//***************************
//  Sp Main
//***************************
static	void	main_4_keta(void)
{
	unsigned short	check_path_valu;
	unsigned short	us;
	unsigned short	ad_ave;
	unsigned char	ucinf;
	unsigned char	disp_clock_mode=HM;
	unsigned char	old_disp_clock_mode=HMS;
	unsigned char	old_rtc_1s_flg=0xff;
	unsigned char	old_RTC_sec = 0xff;
	unsigned char	old_RTC_min = 0xff;
	unsigned char	old_RTC_hou = 0xff;
	unsigned char	old_RTC_mon = 0xff;
	unsigned char	old_RTC_day = 0xff;
	unsigned char	old_RTC_year = 0xff;
	unsigned char	dark = 0;						// 0: 邢  1:Â

	sei();											// 荞݉

	bef1_ad_ave = 0;

	disp_nixie_4binary(0,VER_DATA);					// o[WS\iXXXX܂Łj
	if(VER_DATA/1000 == 0){
		disp_dynamic_nixie_number(0, 15);			// o[Wŏʌ  
	}
	disp_dynamic_colon_on_off(1);					// R@_

	delay_ms(2000);									// 2000mS Delay

	disp_nixie_4binary(0,gBPS_600);					// aorUOOS\iXXXX܂Łj
	disp_dynamic_colon_on_off(0);					// R@

	tim_10ms_nixie = 100;
	dynamic_nixie_active(1);						// _Ci~bN\Jn

	delay_ms(2000);									// 2000mS Delay

	while(1){
		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ
		ucinf = get_infrared_data();							// ԊORfqf[^
		if(us == 0){											// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);							// ԊORf[^XCb`f[^ɕϊ
		}

		if(us == SW1_OFF_LONG){									// ꂽ(set switch)
			proc_no_key_timeup(1);								// L[͂L
			disp_clock_mode = SET;
			proc_set_rtc();										// v킹
			disp_clock_mode = HM;
			old_RTC_year = 0xff;
			old_RTC_mon = 0xff;
			old_RTC_day = 0xff;
			old_RTC_hou = 0xff;
			old_RTC_min = 0xff;
			old_RTC_sec = 0xff;
			old_rtc_1s_flg = (rtc_1s_flg - 1);
		}else if(us == SW2_OFF_SHORT){							// Zꂽ(select switch)
			proc_no_key_timeup(1);								// L[͂L
			switch(disp_clock_mode){							// 샂[hύX
			 case HM:
				disp_clock_mode = MD;
				old_RTC_year = 0xff;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				old_RTC_sec = 0xff;
				break;
			 case MD:
				disp_clock_mode = YE;
				old_RTC_year = 0xff;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				old_RTC_sec = 0xff;
				break;
			 case YE:
				disp_clock_mode = TEMPER;
				old_RTC_year = 0xff;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				old_RTC_sec = 0xff;
				break;
			 case TEMPER:
				disp_clock_mode = CDS;						// b[hɕύX
				old_RTC_year = 0xff;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				old_RTC_sec = 0xff;
				break;
			case CDS:
				disp_clock_mode = HM;
				old_RTC_year = 0xff;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				old_RTC_sec = 0xff;
				break;
			 default:
				disp_clock_mode = HM;
				old_RTC_year = 0xff;
				old_RTC_mon = 0xff;
				old_RTC_day = 0xff;
				old_RTC_hou = 0xff;
				old_RTC_min = 0xff;
				old_RTC_sec = 0xff;
				break;
			}
			old_rtc_1s_flg = (rtc_1s_flg - 1);					// ɕ\
		}else{
			if(rtc_1s_flg != old_rtc_1s_flg){					// qsbĂ鎞̂Pboߗp
#if	AD_NO == 6
				ad6_get_data();									// A/D 6 Get A/D data
				ad_ave = ad6_ave;
#else
 #if	AD_NO == 5
				ad5_get_data();									// A/D 5 Get A/D data
				ad_ave = ad5_ave;
 #else
				ad0_get_data();									// A/D 0 Get A/D data
				ad_ave = ad0_ave;
 #endif
#endif
				ad6_get_data();									// A/D 6 Get A/D data
				old_rtc_1s_flg = rtc_1s_flg;
				rtc_read();										// RTC ǂݏo
				if(disp_clock_mode == HM){						// [h
					tim_10ms_nixie = 50;
					if(old_RTC_hou != gRTC_hou){				// ω
						disp_nixie_tow(0,gRTC_hou);				//  \
						old_RTC_hou = gRTC_hou;
					}
					if(old_RTC_min != gRTC_min){				// ω
						disp_nixie_tow(2,gRTC_min);				//  \
						old_RTC_min = gRTC_min;
					}

					if((gRTC_min == 0)&&(gRTC_sec == 0)){		// ̎
						disp_clock_mode = ANIME;
						disp_animation(1);						// Aj[V
						old_disp_clock_mode = HM;
					}

				}else if(disp_clock_mode == MD){				// [h
					if(old_RTC_mon != gRTC_mon){				// ω
						disp_nixie_tow(0,gRTC_mon);				//  \
						old_RTC_mon = gRTC_mon;
						disp_dynamic_colon_on_off(1);			// R@_
					}
					if(old_RTC_day != gRTC_day){				// ω
						disp_nixie_tow(2,gRTC_day);				//  \
						old_RTC_day = gRTC_day;
						disp_dynamic_colon_on_off(1);			// R@_
					}

					if((gRTC_min == 0)&&(gRTC_sec == 0)){		// ̎
						disp_clock_mode = ANIME;
						disp_animation(1);						// Aj[V
						old_disp_clock_mode = MD;
					}

				}else if(disp_clock_mode == YE){				// N[h
					tim_10ms_nixie = 50;
					if(old_RTC_year != gRTC_year){				// Nω
						disp_nixie_tow(0,0x20);					// NiQOj \
						disp_nixie_tow(2,gRTC_year);			// N \
						old_RTC_year = gRTC_year;
						disp_dynamic_colon_on_off(0);			// R@
					}

					if((gRTC_min == 0)&&(gRTC_sec == 0)){		// ̎
						disp_clock_mode = ANIME;
						disp_animation(1);						// Aj[V
						old_disp_clock_mode = YE;
					}

				}else if(disp_clock_mode == TEMPER){			// x\[h̎
					disp_dynamic_nixie_clear();					// Nixie \SADot
					temperature_read();							// xǂݏo
					disp_nixie_4binary(0,gTemperature);			// S\iXXXX܂Łj
					disp_dynamic_colon_on_off(1);				// R@_

				}else if(disp_clock_mode == CDS){				// b[h̎
					disp_nixie_4binary(0,ad_ave);				// S\iXXXX܂Łj
					disp_dynamic_colon_on_off(0);				// R@

				}else if(disp_clock_mode == Infr_Data){			// ԊOMf[^[h̎
					disp_nixie_4binary(0,Ginf_data);			// S\iXXXX܂Łj
					disp_dynamic_colon_on_off(0);				// R@
				}

				// \x̒
				check_path_valu = change_path;
				check_path_valu *= 100;
				if(dark == 1){									// Â
					if (check_path_valu < 50){
						check_path_valu = 0;
					}else{
						check_path_valu -= 50;
					}
					if (ad_ave < check_path_valu){
						path_limit = 1;
						dark = 0;
					}
				}else{
					check_path_valu += 50;
					if (check_path_valu < ad_ave){
						path_limit = 4;
						dark = 1;
					}
				}
			}

			if (proc_no_key_timeup(0) == 0xff){						// ԃL[͂
				if((disp_clock_mode != HM)&& (disp_clock_mode != ANIME)){	// \ŖŁAAjł
					disp_clock_mode = HM;
					old_RTC_year = 0xff;
					old_RTC_mon = 0xff;
					old_RTC_day = 0xff;
					old_RTC_hou = 0xff;
					old_RTC_min = 0xff;
					old_RTC_sec = 0xff;
				}
			}

			if(tim_10ms_nixie == 0){							// QOO
				if(disp_clock_mode == ANIME){					// Aj[V̎
					tim_10ms_nixie = 20;						// POr^C}[d|
					if(disp_animation(0) == 1){					// \
						disp_clock_mode = old_disp_clock_mode;
						old_RTC_year = 0xff;
						old_RTC_mon = 0xff;
						old_RTC_day = 0xff;
						old_RTC_hou = 0xff;
						old_RTC_min = 0xff;
						old_RTC_sec = 0xff;
					}
				}
			}
		}

		if((tim_10ms_infrared != 0)){
			led_red_on();											// LED ON
		}else{
			led_red_off();											// LED OFF
		}

		if(disp_clock_mode == HM){								// [h̎
			if(tim_10ms_nixie != 0){
				disp_dynamic_colon_on_off(1);					// R@_
			}else{
				disp_dynamic_colon_on_off(0);					// R@
			}
		}

	}
}

//***************************
//  Main
//***************************
int	main(void)
{

	PRR |= ( (1 << PRTWI) | (1 << PRSPI) | (1 << PRUSART0) | (1 << PRTIM0) | (1 << PRTIM1) | (1 << PRTIM2) | (1 << PRADC) );	// TWI, SPI, UART0, Timer0, Timer1, Timer2, ADC ~
	delay_ms(200);									// 200mS Delay

	init_nixe();									// Nixe\ 
	sw_init();										// XCb`֌W̏ݒ
	rtc_init();										// qsb̏ݒ
	led_red_init();									// Ԃkdc֌W̏ݒ
	led_blu_init();									// kdc֌W̏ݒ
	timer2_init();									// Timer2 Initial

	infrared_init();								// ԊORfq Initial

#if	AD_NO == 6
	ad6_init();										// A/D 6 Initial
#else
 #if	AD_NO == 5
	ad5_init();										// A/D 5 Initial
 #else
	ad0_init();										// A/D 0 Initial
 #endif
#endif

	g_keta = KETA_MAX;								// KETA = 14
	path_limit = 1;									// \Ԉ 1--4 (1:bright -- 4:dark)
	change_path = read_eep_change_path();			// ddoqnl change_PATH ǂݍ

	led_red_on();										// LED ON
	delay_ms(500);									// 500mS Delay
	led_red_off();										// LED OFF
	delay_ms(500);									// 500mS Delay
	led_red_on();										// LED ON
	delay_ms(500);									// 500mS Delay
	led_red_off();										// LED OFF
	delay_ms(500);									// 500mS Delay

//----  --ԂkdcƃXCb`̃`FbN-----
//	{
//		unsigned char	uc;
//
//		for(uc = 0;uc < 10;uc++){
//			led_red_on();										// LED ON
//			delay_ms(500);									// 500mS Delay
//			led_red_off();										// LED OFF
//			delay_ms(500);									// 500mS Delay
//			if((PINB & SW2_ON_BIT) == 0){					// XCb`f[^Ă(select switch)
//				break;
//			}
//		}
//
//		for(;;){
//			if((PINB & SW2_ON_BIT) == 0){					// XCb`f[^Ă(select switch)
//				led_red_on();									// LED ON
//			}
//			if((PINB & SW1_ON_BIT) == 0){					// XCb`f[^Ă(set switch)
//				led_red_off();										// LED OFF
//			}
//		}
//	}
//---------------

	if((PINB & SW2_ON_BIT) == 0){					// XCb`f[^Ă(select switch)
		if((PINB & SW1_ON_BIT) == 0){				// XCb`f[^Ă(set switch)
			edit_eep_data();						// ddoqnlDATAҏW
		}
	}

	if((PINB & SW2_ON_BIT) == 0){					// XCb`f[^Ă(select switch)
		check_dynamic();							// `FbNi_Ci~bN\js
	}

	if((PINB & SW1_ON_BIT) == 0){					// XCb`f[^Ă(set switch)
		check_static();								// `FbNiX^eBbN\js
	}

	main_4_keta();									// Sp Main

}
