//*****************************************
// AT mega328P-AU(32pin TQFP) four IN-4 & ZM1020 clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:infrared.c
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2020/09/24 Modify for four IN-8 clock Taishi
//  2022/02/26 Modify for four IN-4 & ZM1020 clock Taishi
//*****************************************
#include	<avr/io.h>

#include	"four_in4_zm1020_clock.h"
#include	"timer.h"
#include	"uart.h"
#include	"infrared.h"

unsigned short	Ginf_data;		// Mf[^ifobOpj

//*****************************************
// ԊORfq Initial
//  荞ݕs̏ԂŌĂ΂Ƃ
//
//*****************************************
void	infrared_init(void)
{
	DDRD &= ~((1 << DDD0));		// Port-D Bit0 : Intput
	PORTD |= ((1 << PD0) );		// Port-D Bit0 : Pullup

	uart_init();				// UART ݒ
}
//***************************
//  ԊORfqԂ
//   ocOFk   M ߂lP
//   ocOFg MȂ ߂lO
//***************************
unsigned char	get_infrared_stat(void)
{
	unsigned char	r = 0;

	if((PIND & (1 << PIND0)) == 0){			//ԊORfqԂ擾
		r = 1;
	}

	return(r);
}
//***************************
//  ԊORfqf[^
//    VAʐMf[^ 's',data1,data2, 'e' ̂Sf[^Ƃ
//    Yf[^ȊOM͍܂ł̃f[^jAX^[gf[^҂ɂȂ
//   ߂l
//		OOO			f[^
//		IND1_ON_NOW			set n߂	'1'
//		IND1_ON_CONTINUE	set A		'2'
//		IND1_OFF_SHORT		set Z		'3'
//		IND1_OFF_LONG		set 		'4'
//		IND2_ON_NOW			select n߂	'5'
//		IND2_ON_CONTINUE	select A		'6'
//		IND2_OFF_SHORT		select Z	'7'
//		IND2_OFF_LONG		select 	'8'
//***************************
enum WAIT_STATE {			// f[^҂[h
		WAIT_START_D = 0,	// X^[gf[^҂
		WAIT_DATA1,			// P҂
		WAIT_DATA2,			// Q҂
		WAIT_END_D,			// Ghf[^҂
	};
#define	START_D	's'
#define	END_D	'e'

unsigned char	get_infrared_data(void)
{
	unsigned char			r = 0;
	static unsigned char	st = WAIT_START_D;
	static unsigned char	uc = 0;
	static unsigned char	inf_data[5] = {0,0,0,0,0};

	r = Get_rxd(&uc);

	if(r != 0){									// Mf[^L
		Ginf_data = uc;							// fobOpf[^ɓ
		tim_10ms_infrared = 10;					// kdc_
		r = 0;
		switch(st){
		 case WAIT_START_D:						// X^[gf[^҂
			if(uc == START_D){					//  X^[gf[^̎
				inf_data[0] = uc;
				st = WAIT_DATA1;
			}
			break;
		 case WAIT_DATA1:						// f[^P҂
			if((INFR_DATA_START < uc) && (uc < INFR_DATA_END)){	//  f[^P͈͓̔̎
				inf_data[1] = uc;				//   f[^Pۑ
				st = WAIT_DATA2;				//   f[^Q҂ɂ
			}else{								//  ͈͊O̎
				st = WAIT_START_D;				//   X^[gf[^҂ɖ߂
			}
			break;
		 case WAIT_DATA2:						// f[^Q҂
			if((INFR_DATA_START < uc) && (uc < INFR_DATA_END)){	//  f[^Q͈͓̔̎
				inf_data[2] = uc;				//   f[^Qۑ
				st = WAIT_END_D;				//   Ghf[^҂ɂ
			}else{								//  ͈͊O̎
				st = WAIT_START_D;				//   X^[gf[^҂ɖ߂
			}
			break;
		 case WAIT_END_D:						// Ghf[^҂
			if(uc == END_D){					//  Ghf[^̎
				inf_data[3] = uc;
				st = WAIT_START_D;
				if(inf_data[1] == inf_data[2]){	//  f[^PƂQ
					r = inf_data[1];			//   ߂lZbg
				}
			}else{								//  Ghf[^ȊO̎
				st = WAIT_START_D;				//   X^[gf[^҂ɖ߂
			}
			break;
		 default:								// ̑̑҂iւ͗Ȃj
			st = WAIT_START_D;
			break;
		}
	}

	return(r);
}

