//*****************************************
// AT mega328P-AU(32pin TQFP) four IN-4 & ZM1020 clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:nixie.c
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2020/09/24 Modify for four IN-8 clock Taishi
//  2022/02/26 Modify for four IN-4 & ZM1020 clock Taishi
//*****************************************

#include	<avr/pgmspace.h>
#include	<avr/io.h>

#include	"four_in4_zm1020_clock.h"
#include	"nixie.h"

// **********************************************************
// *********************** NIXE TUBE ************************
// **********************************************************
//

// **********************************************************
//@jLV[ǂ͂O`R
//@@jLV[ǑI
//@@obO`R̃rbgɂđI
//@@@R@Q@P@O
//@@@k@k@k@k@||@O@@̏㌅
//@@@k@k@k@g@||@P@@̉
//@@@k@k@g@k@||@Q@@̏㌅
//@@@k@k@g@g@||@R@@̉
//
//@@@iAj
//@@\locSCocTCocUCocV̂Srbĝabcōs
//@@@ocV@ocU@ocT@ocS
//@@@k@@@k@@@k@@@k@@||@O
//@@@k@@@k@@@k@@@g@@||@P
//@@@k@@@k@@@g@@@k@@||@Q
//@@@k@@@k@@@g@@@g@@||@R
//@@@k@@@g@@@k@@@k@@||@S
//@@@k@@@g@@@k@@@g@@||@T
//@@@k@@@g@@@g@@@k@@||@U
//@@@k@@@g@@@g@@@g@@||@V
//@@@g@@@k@@@k@@@k@@||@W
//@@@g@@@k@@@k@@@g@@||@X
//@@@g@@@k@@@g@@@k@@||@
//@@@g@@@k@@@g@@@g@@||@
//@@@g@@@g@@@k@@@k@@||@
//@@@g@@@g@@@k@@@g@@||@
//@@@g@@@g@@@g@@@k@@||@
//@@@g@@@g@@@g@@@g@@||@
//
//@@R͂ocPi΁jƂocQiԁjŐ䂵AjLV[ǂƂ͖֌WɐłB
//
// **********************************************************

unsigned char	path_limit = 1;
unsigned char	change_path = 2;

static	unsigned char	nixie_data[KETA_MAX+2];			// +1 ŗǂAÔ
static	unsigned char	nixie_select[KETA_MAX+2];		// +1 ŗǂAÔ
static	unsigned char	nixie_act_num = 0;
static	unsigned char	dynamic_nixie = 0;
static	unsigned char	nixie_colon;					// R̂nmiQj^neeiOj


#define		NIXE_SELECT_DIS		0b11000000	// PC0 -- 5 = all 0
#define		NIXE_NUMBER_OFF		0b11110000	// PD4--7:'H'
#define		NIXE_NUMBER_MASK	0b00001111	// PD4--7:'L'ɂ鎞
#define		NIXE_COLON_RED_ON	0b00000010	// PD1:'H'
#define		NIXE_COLON_GRN_ON	0b00000100	// PD2:'H'
//******************************
//  Nixe\@
// *****************************
void	init_nixe(void)
{
	unsigned char	uc;

	PORTC &= NIXE_SELECT_DIS;							// IȂ


	PORTD |= NIXE_NUMBER_OFF;							// Ȃ
	PORTD &= ~(NIXE_COLON_GRN_ON | NIXE_COLON_RED_ON);	// RȂ

// o̓|[g̐ݒigȂ ͂ƃmCŶŁ@o͂ɂ
	DDRD |= ((1 << DDD1) | (1 << DDD4) | (1 << DDD5) | (1 << DDD6) | (1 << DDD7));	// Port-D Bit1,4567 : Output
	DDRD |= ((1 << DDD1) | (1 << DDD2) | (1 << DDD4) | (1 << DDD5) | (1 << DDD6) | (1 << DDD7));	// Port-D Bit12,4567 : Output
	DDRC |= ((1 << DDC0) | (1 << DDC1) | (1 << DDC2) | (1 << DDC3) | (1 << DDC4) | (1 << DDC5));	// Port-C Bit012345 : Output

// \AR f[^
	for(uc = 0;uc <= KETA_MAX; uc++){
		nixie_data[uc] = NIXE_NUMBER_OFF;		// NA
	}
	nixie_colon = 0;					// R̐ԂnmiQj^΂nmiSj^neeiOj

	nixie_select[0] = 0b00000001;		// ŏʁ@̏㌅
	nixie_select[1] = 0b00000010;		// Qʁ@̉
	nixie_select[2] = 0b00000100;		// Rʁ@̏㌅
	nixie_select[3] = 0b00001000;		// ŉʁ@b̉

	nixie_act_num = 0;

	dynamic_nixie = 0;
}
//******************************
// jLV[Ǖ\
// sQ̊荞݂ŌĂ΂
//  for four in-4 & ZM1020 Clock
//******************************
void	proc_dynamic_nixie(void)
{
	static	unsigned char	path=0;

	if(dynamic_nixie == 1){
		if(path == path_limit){

			PORTC &= NIXE_SELECT_DIS;							// IȂ

			PORTD |= NIXE_NUMBER_OFF;							// Ȃ
			PORTD &= ~(NIXE_COLON_GRN_ON | NIXE_COLON_RED_ON);	// OFF Colon
			if(nixie_act_num == KETA_SEL_MAX){					// R
				PORTD |= nixie_colon;							// ON or OFF Colon
			}else if(nixie_act_num < KETA_SEL_MAX){				// ijLV[ǁj
				PORTD &= NIXE_NUMBER_MASK;						// }XN
				PORTD |= nixie_data[nixie_act_num];				// 
				PORTC |= nixie_select[nixie_act_num];			// I
			}

			if(KETA_SEL_MAX <= nixie_act_num){
				nixie_act_num = 0;
			}else{
				nixie_act_num++;
			}
		}else if(path == 0){
			PORTC &= NIXE_SELECT_DIS;							// IȂ

			PORTD |= NIXE_NUMBER_OFF;							// Ȃ
			PORTD &= ~(NIXE_COLON_GRN_ON | NIXE_COLON_RED_ON);	// OFF Colon
		}

		path++;
		if(PATH_MAX < path){
			path = 0;
		}

	}
}

//******************************
// Dynamic Nixie display Active/Non active
//  on : 1= Active, other=Non Active
// *****************************
void	dynamic_nixie_active(unsigned char on)
{
	dynamic_nixie = on;
}

//******************************
// Nixie \i_Ci~bN_j
//  k : ʒuiO`TAOFŏʁEEETFŉʁj
//  n : O`XAPTiPT͋󔒁j
// *****************************
void	disp_dynamic_nixie_number(unsigned char k, unsigned char n)
{
	if(KETA_MAX < k){						// IlُȎ
		k = 0;								// Iɍŏʂɂ
	}

	dynamic_nixie_active(0);				// _Ci~bN\~
	nixie_data[k] = ((n << 4) & 0xf0);
	dynamic_nixie_active(1);				// _Ci~bN\ĊJ
}

// *****************************
// Nixie b\i_Ci~bN_j
//  n : O(OFF) or 1(ON)
// *****************************
void	disp_dynamic_colon_on_off(unsigned char n)
{
	if(n == 0){
		nixie_colon = 0;
	}else{
		nixie_colon = (NIXE_COLON_GRN_ON | NIXE_COLON_RED_ON);
	}
}
//******************************
// Nixie \SAci_Ci~bN_j
// *****************************
void	disp_dynamic_nixie_clear(void)
{
	unsigned char uc;

	for(uc=0;uc <= KETA_MAX; uc++){
		disp_dynamic_nixie_number(uc, 15);		//   
	}
	disp_dynamic_colon_on_off(0);				// Colon OFF
}

//******************************
// Nixie \iX^eBbNN_j
//  k : ʒuiO`TAOFŏʁEEETFŉʁj
//  n : O`XAPTiPT͋󔒁j
//   _Ci~bN\͍sĂȂԂɌ
// *****************************
void	disp_static_nixie_number(unsigned char k, unsigned char n)
{
	PORTC &= NIXE_SELECT_DIS;			// IȂ

	PORTD |= NIXE_NUMBER_OFF;			// Ȃ
	PORTD &= ~(NIXE_COLON_GRN_ON | NIXE_COLON_RED_ON);			// OFF Colon

	if(KETA_MAX < k){					// IlُȎ
		k = 0;							// Iɍŏʂɂ
	}

	PORTD &= NIXE_NUMBER_MASK;			// }XN
	PORTD |= ((n << 4) & 0xf0);			// 

	PORTC |= nixie_select[k];			// I


}
//******************************
// Neon Colon\iX^eBbNN_j
//  n : O(OFF) or 1(ON)
//   _Ci~bN\͍sĂȂԂɌ
// *****************************
void	disp_static_colon_on_off(unsigned char n)
{
	PORTC &= NIXE_SELECT_DIS;			// IȂ

	PORTD |= NIXE_NUMBER_OFF;			// Ȃ
	PORTD &= ~(NIXE_COLON_GRN_ON | NIXE_COLON_RED_ON);			// OFF Colon

	if(n != 0){
		PORTD |= (NIXE_COLON_GRN_ON | NIXE_COLON_RED_ON);		// COLON : ON
	}

}

