//*****************************************
// AT mega328P-AU(32pin TQFP) four IN-4 & ZM1020 clock Program
// CPU Clock:8MHz
// File Name:rtc_ds3234.h
//  wb_[t@C
//
// Real Time Clock DS3234
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2020/09/24 Modify for four IN-8 clock Taishi
//  2022/02/26 Modify for four IN-4 & ZM1020 clock Taishi
//*****************************************

#define	RTC_ERR_SPI_WRITE			2
#define	RTC_ERR_SPI_READ			4

extern	unsigned char	gRTC_sec;				// qsb b̃f[^ (BCD 0--59)
extern	unsigned char	gRTC_min;				// qsb ̃f[^ (BCD 0--59)
extern	unsigned char	gRTC_hou;				// qsb ̃f[^ (BCD 0--23j
extern	unsigned char	gRTC_wday;				// qsb j̃f[^ (BCD 1--7)
extern	unsigned char	gRTC_day;				// qsb ̃f[^ (BCD 1--31)
extern	unsigned char	gRTC_mon;				// qsb ̃f[^ (BCD 1--12j
extern	unsigned char	gRTC_year;				// qsb Ñf[^ (BCD 0--99)
extern	unsigned char	gRTC_control;			// qsb Rg[̃f[^
extern	unsigned char	gRTC_status;			// qsb XeC^X̃f[^
extern	unsigned int	gTemperature;			// qsb xf[^iPOO{̒l 3075 : 30.75xj

#define	RTC_CONTROL_ADDR	0x0e				// Rg[̂qsbAhX
#define	RTC_CONTROL_A1IE	0x01
#define	RTC_CONTROL_A2IE	0x02
#define	RTC_CONTROL_INTCN	0x04
#define	RTC_CONTROL_RS1		0x08
#define	RTC_CONTROL_RS2		0x10
#define	RTC_CONTROL_CONV	0x20
#define	RTC_CONTROL_BBSQW	0x40
#define	RTC_CONTROL_EOC		0x80

#define	RTC_SATUS_ADDR		0x0f				// XeC^X̂qsbAhX
#define	RTC_CONTROL_A1F		0x01
#define	RTC_CONTROL_A2F		0x02
#define	RTC_CONTROL_BSY		0x04
#define	RTC_CONTROL_EN32kHz	0x08
#define	RTC_CONTROL_OSF		0x80

#define	RTC_TEMPE_UP_ADDR	0x11				// xʃf[^̂qsbAhX
#define	RTC_TEMPE_UP_SIGN	0x80				// xʃf[^̕rbgiOŐAPŕj
												// ̃f[^
#define	RTC_TEMPE_DW_ADDR	0x12				// xʃf[^̂qsbAhX
												// _ȉ̃f[^D7,D6݂̂ D70.5AD60.25

extern	unsigned char	gCount_sqw;				// rpvM̃JEg
extern	unsigned char	rtc_1s_flg;				// qsbĂ鎞̂Pboߗp



extern	void			rtc_init(void);
extern	void			rtc_read(void);
extern	void			rtc_write(void);
extern	void			rtc_control_read(void);
extern	void			rtc_control_write(void);
extern	void			rtc_status_read(void);
extern	void			rtc_status_write(void);
extern	void			rtc_read_data_clear(void);
extern	void			temperature_start(void);
extern	void			temperature_read(void);

