//*****************************************
// AT mega328P-AU(32pin TQFP) four IN-4 & ZM1020 clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:timer.c
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2020/09/24 Modify for four IN-8 clock Taishi
//  2022/02/26 Modify for four IN-4 & ZM1020 clock Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"four_in4_zm1020_clock.h"
#include	"nixie.h"
#include	"ad_conv.h"

#include	"timer.h"

// **********************************************************
// ********************** Soft Timer ************************
// **********************************************************

volatile unsigned int	wait_i;
volatile unsigned int	wait_j;
volatile unsigned char	wait_us;
// ************************************
// Delay 2uS
// t: uS (max 255)
// CPU Clock:8.000MHz
//  while ߂ for ŎԂ킹Ă
// ************************************
void delay_2us(unsigned char t)
{
	unsigned char	i;

	for(i=0;i<t;i++){
		wait_us++;				// 1uS Delay??
		wait_us++;				// 1uS Delay??
		wait_us++;				// 1uS Delay??
	}
}
//***************************
// Wait
//  tm : Wait Time(ms) max. 8000
// CPU Clock:1MHz
//***************************
void	delay_ms(int tm)
{

	for(wait_i = 0; wait_i < tm; wait_i++){
		delay_2us(500/2);
		delay_2us(500/2);
	}
}

// **********************************************************
// ************************ Timer 1 *************************
// **********************************************************

//int		pulse_out;
//int		pulse_period;
//int		pulse_unit;
//static	unsigned char	tim1_unit[5]={
//	(1 << CS10),					// 1/1
//	(1 << CS11),					// 1/8
//	((1 << CS11) | (1 << CS10)),	// 1/64
//	(1 << CS12),					// 1/256
//	((1 << CS12) | (1 << CS10)),	// 1/1024
//};
//*****************************************
// Timer1 close
//*****************************************
void	timer1_close(void)
{
	TCCR1B = 0x00;														// Timer1 Stop

	TCNT1 = 0;															// Timer1 Count Set to ZERO
	TCCR1A = 0;															//
	TCCR1B = 0;															//

}

//*****************************************
// Timer1 Initial
//  PD4(OC1B): Pulse Out for High Volt Generator
//*****************************************
void	timer1_init(void)
{
	TCCR1B = 0x00;														// Timer1 Stop
	PRR &= ~( 1 << PRTIM1 );											// Timer1 ғ

	TCNT1 = 0;															// Timer1 Count Set to ZERO
	TCCR1A = ( (0 << COM1A1) | (0 << COM1A0) | (0 << COM1B1) | (0 << COM1B0) | (0 << WGM11) | (0 << WGM10) );	// W TOP= 0xffff,
	TCCR1B = ( (0 << WGM13) | (0 << WGM12) | (1 << CS12) | (0 << CS11) | (1 << CS10) );							// W 1/1024

}

//***************************
// Timer1 Comper Match A Interrupt
//
//  ̏125uS Ԋu
// Ă΂Ȃ͂
//***************************
ISR	(TIMER1_COMPA_vect)	
{
}
//***************************
// Timer1 Comper Match B Interrupt
//
//  ̏125uS Ԋu
// Ă΂Ȃ͂
//***************************
ISR	(TIMER1_COMPB_vect)	
{
}
// **********************************************************
// ************************ Timer 2 *************************
// **********************************************************
static unsigned char	tim_intr_for_10ms;		// 10mSPʂJE^[
static unsigned char	tim_10ms_for_1s;		// PbPʂJE^[
unsigned char	tim_10ms_ad;					// `^cf[^擾pPOrPʃ^C}[
unsigned char	tim_10ms_sw;					// XCb`͗pPOrPʃ^C}[
unsigned char	tim_10ms_sw1_length;			// XCb`pԂPOrPʃ^C}[@|P
unsigned char	tim_10ms_sw1_continue;			// XCb`pAPOrPʃ^C}[@|P
unsigned char	tim_10ms_sw2_length;				// XCb`pԂPOrPʃ^C}[@|P
unsigned char	tim_10ms_sw2_continue;			// XCb`pAPOrPʃ^C}[@|P
unsigned char	tim_1s_no_key_timeup;			// L[͂Ȃ̃^CAbvp
unsigned char	count_1s_disp;					// t[̂PbJE^[
unsigned char	tim_10ms_blink;					// \uNpPOrPʃ^C}[
unsigned char	tim_10ms_nixie;					// jLV[\̃^C~OpPOrPʃ^C}[
unsigned char	tim_10ms_infrared;				// ԊORfqpPOrPʃ^C}[
unsigned char	value_for_10ms;					// ݎ10mSPʂl
//*****************************************
// Timer2 Initial
//  1mS 荞݂ɐݒ肷
//*****************************************
void	timer2_init(void)
{
	TCCR2B = 0;											// Timer Stop
	PRR &= ~( 1 << PRTIM2 );							// Timer2 ғ
	TCNT2 = 0;											// Timer2 Count Set to ZERO
	TCCR2A = ((1 << WGM21) | (0 << WGM20));				// A Comper Match, Dont Output Timer2 Signal

// 1000uS Interrupt
//	OCR2A  = COUNT_1MS;									// 1mS at 8MHz/32=250kHz
//	TCCR2B = D_TCCR2B_1000;								// Timer Start (8MHz/32= 250kHz, 4uS)
//	value_for_10ms = VAL_FOR_10MS_1000;
//////

// 500uS Interrupt
	OCR2A  = COUNT_05MS;								// 0.5mS at 8MHz/32=250kHz
	TCCR2B = D_TCCR2B_500;								// Timer Start (8MHz/32= 250kHz, 4uS)
	value_for_10ms = VAL_FOR_10MS_500;
//////

// 250uS Interrupt
//	OCR2A  = COUNT_025MS;								// 0.25mS at 8MHz/8=1000kHz
//	TCCR2B = D_TCCR2B_250;								// Timer Start (8MHz/8= 1000kHz, 1uS)
//	value_for_10ms = VAL_FOR_10MS_250;
//////

// 200uS Interrupt
//	OCR2A  = COUNT_02MS;								// 0.2mS at 8MHz/8=1000kHz
//	TCCR2B = D_TCCR2B_200;								// Timer Start (8MHz/8= 1000kHz, 1uS)
//	value_for_10ms = VAL_FOR_10MS_200;
//////

// 100uS Interrupt
//	OCR2A  = COUNT_01MS;								// 0.1mS at 8MHz/8=1000kHz
//	TCCR2B = D_TCCR2B_100;								// Timer Start (8MHz/8= 1000kHz, 1uS)
//	value_for_10ms = VAL_FOR_10MS_100;
//////

	TIMSK2 |= (1 << OCIE2A);							// A Comper Match Interrupt Enable

	tim_intr_for_10ms = 1;								// 10mSPʂJE^[
	tim_10ms_for_1s = 0;								// PbPʂJE^[
	tim_10ms_ad = 0;									// `^cf[^擾pPOrPʃ^C}[
	tim_10ms_sw = 0;									// XCb`͗pPOrPʃ^C}[
	tim_10ms_sw1_length = 0;							// XCb`PpԂPOrPʃ^C}[@|P
	tim_10ms_sw1_continue = 0;							// XCb`PpAPOrPʃ^C}[@|P
	tim_10ms_sw2_length = 0;							// XCb`QpԂPOrPʃ^C}[@|P
	tim_10ms_sw2_continue = 0;							// XCb`QpAPOrPʃ^C}[@|P
	tim_1s_no_key_timeup = 0;							// L[͂Ȃ̃^CAbvp
	count_1s_disp = 0;									// t[̂PbJE^[
	tim_10ms_blink = 0;									// \uNpPOrPʃ^C}[
	tim_10ms_nixie = 0;									// jLV[\̃^C~OpPOrPʃ^C}[
	tim_10ms_infrared = 0;								// ԊORfqpPOrPʃ^C}[

}
//*****************************************
// Timer2 Close
//  Timer2 ̎gp߂
//*****************************************
void	timer2_close(void)
{
	TCCR2B = 0;											// Timer Stop
	TCNT2 = 0;											// Timer2 Count Set to ZERO
	TCCR2A = 0;											// Dont Output Timer2 Signal
	TIMSK2 = 0;											// Interrupt Disable

}
//***************************
// Timer2 Comper Match A Interrupt
//
//  0.5mS or 0.25mS or 0.2mS or 0.1mS
//***************************
ISR	(TIMER2_COMPA_vect)	
{
	tim_intr_for_10ms--;
	if(tim_intr_for_10ms == 0){					// POrɂȂ
		tim_intr_for_10ms = value_for_10ms;
		tim_10ms_for_1s++;
		if(100 <= tim_10ms_for_1s){				// Pbo
			tim_10ms_for_1s = 0;
			count_1s_disp++;					// t[̂PbJE^[
		}

		if(tim_10ms_ad != 0){
			tim_10ms_ad--;						// `^cf[^擾pPOrPʃ^C}[@|P
		}

		if(tim_10ms_sw != 0){
			tim_10ms_sw--;
		}

		if(tim_10ms_sw1_continue != 0){
			tim_10ms_sw1_continue--;			// XCb`PpAPOrPʃ^C}[@|P
		}

		if(tim_10ms_sw1_length != 0){
			tim_10ms_sw1_length--;				// XCb`PpԂPOrPʃ^C}[@|P
		}

		if(tim_10ms_sw2_continue != 0){
			tim_10ms_sw2_continue--;			// XCb`QpAPOrPʃ^C}[@|P
		}

		if(tim_10ms_sw2_length != 0){
			tim_10ms_sw2_length--;				// XCb`QpԂPOrPʃ^C}[@|P
		}

		if(tim_10ms_blink != 0){
			tim_10ms_blink--;
		}

		if(tim_10ms_nixie != 0){
			tim_10ms_nixie--;
		}

		if(tim_10ms_infrared != 0){				// ԊORfqpPOrPʃ^C}[
			tim_10ms_infrared--;
		}

#if	AD_NO == 6
		ad6_set_data();							// A/D6  Set A/D data to Data Buffer
#else
 #if	AD_NO == 5
		ad5_set_data();							// A/D5  Set A/D data to Data Buffer
 #else
		ad0_set_data();							// A/D0  Set A/D data to Data Buffer
 #endif
#endif

	}
	proc_dynamic_nixie();
}

//***************************
// ԃL[͂̔f
//@ on:1 = L[LA@0= ^CAbṽ`FbN
//  ߂l@O@^CAbvĂȂ
//@@O@^CAbv
//***************************
unsigned char	proc_no_key_timeup(unsigned char on)
{
	unsigned char	r=0;

	if (on == 1){
		tim_1s_no_key_timeup = TIM_DISP_RETURN;		// ^CAbv̎Ԑݒ
	}else{
		if(tim_1s_no_key_timeup == 0){				// ^CAbv
			r = 0xff;
		}
	}
	return(r);
}
