//*****************************************
// AT mega328P-AU(32pin TQFP) four IN-4 & ZM1020 clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:timer.h
//  wb_[t@C
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2020/09/24 Modify for four IN-8 clock Taishi
//  2022/02/26 Modify for four IN-4 & ZM1020 clock Taishi
//*****************************************

extern	void	delay_2us(unsigned char t);
extern	void	delay_ms(int tm);

// ************************ Timer 1 *************************
extern	void	timer1_init(void);
extern	void	timer1_close(void);

// ************************ Timer 2 *************************
// 1000uS(1mS) Interrupt
#define		COUNT_1MS			250											// 1mS at 8MHz/32 = 250kHz(4uS)
#define		D_TCCR2B_1000		((0 << CS22) | (1 << CS21) | (1 << CS20))	// Timer Start (8MHz/32= 250kHz, 4uS)
#define		VAL_FOR_10MS_1000	10											// ݎ10mSPʂl

// 500uS Interrupt
#define		COUNT_05MS			125											// 0.5mS at 8MHz/32 = 250kHz(4uS)
#define		D_TCCR2B_500		((0 << CS22) | (1 << CS21) | (1 << CS20))	// Timer Start (8MHz/32= 250kHz, 4uS)
#define		VAL_FOR_10MS_500	20											// ݎ10mSPʂl

// 250uS Interrupt
#define		COUNT_025MS			250											// 0.25mS at 8MHz/82 = 1000kHz(1uS)
#define		D_TCCR2B_250		((0 << CS22) | (1 << CS21) | (0 << CS20))	// Timer Start (8MHz/8= 1000kHz, 1uS)
#define		VAL_FOR_10MS_250	40											// ݎ10mSPʂl

// 200uS Interrupt
#define		COUNT_02MS			200											// 0.25mS at 8MHz/82 = 1000kHz(1uS)
#define		D_TCCR2B_200		((0 << CS22) | (1 << CS21) | (0 << CS20))	// Timer Start (8MHz/8= 1000kHz, 1uS)
#define		VAL_FOR_10MS_200	50											// ݎ10mSPʂl

// 100uS Interrupt
#define		COUNT_01MS			100											// 0.1mS at 8MHz/82 = 1000kHz(1uS)
#define		D_TCCR2B_100		((0 << CS22) | (1 << CS21) | (0 << CS20))	// Timer Start (8MHz/8= 1000kHz, 1uS)
#define		VAL_FOR_10MS_100	100											// ݎ10mSPʂl

extern	unsigned char	tim_10ms_ad;					// `^cf[^擾pPOrPʃ^C}[
extern	unsigned char	tim_10ms_sw;					// XCb`͗pPOrPʃ^C}[
extern	unsigned char	tim_10ms_sw1_length;			// XCb`PpԂPOrPʃ^C}[@|P
extern	unsigned char	tim_10ms_sw1_continue;			// XCb`PpAPOrPʃ^C}[@|P
extern	unsigned char	tim_10ms_sw2_length;			// XCb`QpԂPOrPʃ^C}[@|P
extern	unsigned char	tim_10ms_sw2_continue;			// XCb`QpAPOrPʃ^C}[@|P
extern	unsigned char	tim_1s_no_key_timeup;			// L[͂Ȃ̃^CAbvp
extern	unsigned char	tim_10ms_blink;					// \uNpPOrPʃ^C}[
extern	unsigned char	tim_10ms_nixie;					// jLV[\̃^C~OpPOrPʃ^C}[
extern	unsigned char	tim_10ms_infrared;				// ԊORfqpPOrPʃ^C}[
extern	void			timer2_init(void);
extern	void			timer2_close(void);
extern	unsigned char	proc_no_key_timeup(unsigned char on);
