//*****************************************
// AT mega328P-AU(32pin TQFP) four IN-4 & ZM1020 clock Program
// CPU Clock:8MHz
//   iq[Yf[^@WȂBIV[^(8MHz)ɂj
//
// File Name:uart.h
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2020/09/24 Modify for four IN-8 clock Taishi
//  2022/02/26 Modify for four IN-4 & ZM1020 clock Taishi
//*****************************************


#define	BIT_RATE600			600								// rbg|g:600
#define	BIT_RATE1200		1200							// rbg|g:1200
#define	BIT_RATE2400		2400							// rbg|g:2400
#define	BIT_RATE4800		4800							// rbg|g:4800
#define	BIT_RATE9600		9600							// rbg|g:9600


// t`qs̐ݒl

// aor
#define	BPS_600			(unsigned int)(((long)CPU_CLOCK/(long)16/(long)BIT_RATE600) - 1)	// taqqO̒l(600)
#define	BPS_1200		(unsigned int)(((long)CPU_CLOCK/(long)16/(long)BIT_RATE1200) - 1)	// taqqO̒l(1200)
#define	BPS_2400		(unsigned int)(((long)CPU_CLOCK/(long)16/(long)BIT_RATE2400) - 1)	// taqqO̒l(2400)
#define	BPS_4800		(unsigned int)(((long)CPU_CLOCK/(long)16/(long)BIT_RATE4800) - 1)	// taqqO̒l(4800)
#define	BPS_9600		(unsigned int)(((long)CPU_CLOCK/(long)16/(long)BIT_RATE9600) - 1)	// taqqO̒l(9600)

// peB
#define	V_PARITY_NON	((0 << UPM01) | (0 << UPM00))									// peB
#define	V_PARITY_EVN	((1 << UPM01) | (0 << UPM00))									// peB
#define	V_PARITY_ODD	((1 << UPM01) | (1 << UPM00))									// peB

// f[^
#define	V_DATA_8		((1 << UCSZ00) | (1 << UCSZ01))									// Wrbgf[^
#define	V_DATA_7		((0 << UCSZ00) | (1 << UCSZ01))									// Vrbgf[^

// tbrqO`̒l
#define	V_UCSR0A		(0 << U2X0)														// tbrqO`̒l: WiWlg͔̎{̕덷Ȃj

// tbrqOa̒l
//#define	V_UCSR0B		(1 << TXEN0)												// tbrqOa̒l: M
//#define	V_UCSR0B		((1 << RXEN0) | (1 << RXCIE0) | (1 << TXEN0))				// tbrqOa̒l: MAM荞݉AM
#define	V_UCSR0B		((1 << RXEN0) | (1 << RXCIE0))									// tbrqOa̒l: MAM荞݉

extern	unsigned short	gBPS_600;

extern	void			uart_init(void);
extern	void			uart_close(void);

#if	0
extern	void			uart_tx_one(unsigned char uc);
extern	void			uart_tx_str(char *str);
extern	void			uart_tx_str_crlf(char *str);
#endif

extern	unsigned char	Get_rxd(unsigned char *uc);

